<?php
/*
Plugin Name: NM-Delete-Revision
Plugin URI: http://www.ankurb.info/2009/01/11/nm-delete-revision/
Description: Delete redundant post revisions in your WordPress database.
Author: greatquizzard, gohsy
Version: 1.2
Author URI: http://www.ankurb.info
*/


if(!get_option('del_revision_no'))
	update_option("del_revision_no",0);
		
if(!get_option('del_revision_getPosts'))
	update_option("del_revision_getPosts",0);
	

	/* $dr_locale = get_locale();
	$dr_mofile = dirname(__FILE__) . "/delete-revision-$dr_locale.mo";
	load_textdomain('delete-revision', $dr_mofile); */
	
function delete_revision_main()
{
    if (function_exists('add_options_page'))
	add_options_page('NM-Delete-Revision', 'NM-Delete-Revision',8, basename(__FILE__), 'my_options_delete_revision');
}

add_action('admin_menu', 'delete_revision_main');

function my_options_delete_revision()
{
	$dr_ver = 1.2;
	$get_my_posts = get_my_posts();
	$del_revision_no = get_option('del_revision_no');
	echo <<<EOT
	<div class="wrap">
		<h2>NM-Delete-Revision Manager  <font size=1>ver $dr_ver</font></h2>
		<div style="padding:5px 0;border:1px dashed #80B5D0;padding:10px;background:#E4F2FD;margin:15px 0;">
EOT;
		printf(__("You currently have <span style='color:red;font-weight:bold;'> %s </span> posts in your blog. NM-Delete-Revision has detected <span style='color:red;font-weight:bold;'> %s </span> instances of post revision redundancy on your blog till date.",'nm-delete-revision'), $get_my_posts,$del_revision_no);
		echo '</div>';

		
	if (isset($_POST['del_act']))
	{
		delete_revision_act();
		$del_no = $_POST['rev_no'];
		update_option("del_revision_no",get_option("del_revision_no") + $del_no);
		echo '<div class="updated" style="margin-top:50px;"><p><strong>';
		printf(__("Deleted <span style='color:red;font-weight:bolder;'> %s </span> redundant revisions!",'nm-delete-revision'),$del_no);	
		echo '</strong></p></div></div>';
	}
	
	elseif (isset($_POST['get_rev']))
		get_my_revision();
		
	else
	{
		echo '<form method="post" action="">';
		echo '<input type="submit" name="get_rev" value="';
		_e('Check for redundant revisions','nm-delete-revision');
		echo '" /></form></div>';
	}
}

function get_my_posts()
{
	global $wpdb;
	$sql = "SELECT ID
			FROM (
			$wpdb->posts
			)
			WHERE `post_type` = 'post'";
	$results = $wpdb -> get_results($sql);
	return count($results);
}

function get_my_revision()
{
	global $wpdb;
	$sql = "SELECT `ID`,`post_date`,`post_title`,`post_modified`
			FROM (
			$wpdb->posts
			)
			WHERE `post_type` = 'revision'
			ORDER BY `ID` DESC";
	$results = $wpdb -> get_results($sql);
	if($results)
	{
		$res_no = count($results);
		echo "<table>";
		echo "<tr style=\"background:#C6D9E9\"><td width=30> Id </td><td width=450> Title </td><td width=180> Post date </td><td width=180> Last modified </td></tr>";
		for($i = 0 ; $i < $res_no ; $i++)
		{
			echo "<tr><td>".$results[$i] -> ID."</td>";
			echo "<td>".$results[$i] -> post_title."</td>";
			echo "<td>".$results[$i] -> post_date."</td>";
			echo "<td>".$results[$i] -> post_modified."</td></tr>";
		}
		echo "</table><br />";
		echo <<<EOT
			<form method="post" action="">
			<input type="hidden" name="rev_no" value=" $res_no " />
EOT;
			echo '<input type="submit" name="del_act" value="';
			printf(__('Yes, I want to delete the %s revisions listed above','nm-delete-revision'),$res_no);
			echo '" /><input type="submit" name="goback" value="';
			_e('No, I do not want the above revisions to be deleted','nm-delete-revision');
			echo '" /></form></div>';

	}
	
	else
	{
		echo "<div class=\"updated\" style=\"margin:50px 0;padding:6px;line-height:16pt;font-weight:bolder;\">";
		_e('You do not have any revisions in your WordPress database.','nm-delete-revision');
		echo "</div></div>";
	}
}

function delete_revision_act()
{
	global $wpdb;
	$sql = "DELETE FROM $wpdb->posts WHERE post_type = 'revision'";
	$results = $wpdb -> get_results($sql);
}

?>
